! ============================================================
SUBROUTINE BruteForce(filename, good, vL, vU, vs, bndsrcL, bndsrcU, dXc, operative)
!DEC$ ATTRIBUTES DLLEXPORT :: BruteForce

USE Globals_class, ONLY : dimXc, dimX, erase, AssignX, AssignB, A, omega, phi, dl0, l0, dth0, th0, dps0, ps0, fb1, fb2, fb3,&
						  active, brute, tunnel
USE ReadFiles_class
USE LeastSquares_class
USE Verbatim_class, ONLY : Verba

! Subroutine che gestisce il flusso dell'elaborazione
!
! PARAMETRI DI INPUT
!
! PARAMETRI DI OUTPUT:

IMPLICIT NONE

! Variables
CHARACTER(LEN=*), INTENT(IN) :: filename
INTEGER, INTENT(IN) :: dXc
REAL(8), INTENT(IN) :: vL(dXc), vU(dXc), vs(dXc), bndsrcL(dXc), bndsrcU(dXc)
LOGICAL, INTENT(IN) :: operative(3), good(dXc)
INTEGER, PARAMETER :: m = 1
REAL(8), PARAMETER :: TOLLs = 1.d-6, TOLL = 1.d-2
INTEGER :: p, IPARAM(6) !, iter
!CHARACTER(LEN=10) :: it
REAL(8), ALLOCATABLE :: X(:), XF(:), XFB(:), XLM(:), XLB(:), XUB(:)

! Inizio procedimento
dimXc = dXc
brute = .TRUE.

IF (ALLOCATED(active)) DEALLOCATE(active)
ALLOCATE(active(dimXc))
active = good

erase = 0.d0
DO p = 1, dimXc
	IF (active(p).EQ..FALSE.) erase = erase+1
END DO
dimX = dimXc-erase

OPEN(UNIT=6, FILE='lsnl.dat', STATUS='REPLACE', ACTION='WRITE')
!iter = 1

! 9216 iterazioni --> 1 iteraz al sec --> 153.6 min --> 2.56 ore
DO A = vL(1), vU(1), vs(1)
DO omega = vL(2), vU(2), vs(2)
DO phi = vL(3), vU(3), vs(3)
DO dl0 = vL(4), vU(4), vs(4)
DO dps0 = vL(8), vU(8), vs(8)
DO dth0 = vL(6), vU(6), vs(6)
DO ps0 = vL(9), vU(9), vs(9)
DO th0 = vL(7), vU(7), vs(7)
DO l0 = vL(5), vU(5), vs(5)
DO fb3 = vL(12), vU(12), vs(12)
DO fb2 = vL(11), vU(11), vs(11)
DO fb1 = vL(10), vU(10), vs(10)

!fb3=SQRT(1.1d0**2.d0-fb2**2.d0)

IF (ALLOCATED(X)) DEALLOCATE(X)
IF (ALLOCATED(XLB)) DEALLOCATE(XLB)
IF (ALLOCATED(XUB)) DEALLOCATE(XUB)
ALLOCATE(X(dimX))
ALLOCATE(XLB(dimX))
ALLOCATE(XUB(dimX))
CALL AssignX(X)
CALL AssignB(bndsrcL, bndsrcU, XLB, XUB)

IF ((operative(2).EQ..TRUE.).OR.(operative(3).EQ..TRUE.)) THEN
	IF (ALLOCATED(XLM)) DEALLOCATE(XLM)
	ALLOCATE(XLM(dimX))
	XLM = X
END IF

IF (operative(2).EQ..TRUE.) THEN
	IF (ALLOCATED(XF)) DEALLOCATE(XF)
	ALLOCATE(XF(dimX))
END IF

IF (operative(3).EQ..TRUE.) THEN
	IF (ALLOCATED(XFB)) DEALLOCATE(XFB)
	ALLOCATE(XFB(dimX))
END IF

CALL ReadFile(filename)

tunnel = .FALSE.

IF ((operative(1).EQ..FALSE.).AND.(operative(2).EQ..FALSE.).AND.(operative(3).EQ..FALSE.)) THEN
	CALL Tunneling(XLM, 100, 100, XF)
ELSE
	IF (operative(1).EQ..TRUE.) THEN
		CALL LeastSquares(X, TOLLs, TOLL, m)
	END IF
	IF (operative(2).EQ..TRUE.) THEN
		CALL LevenMarq(XLM, XF, IPARAM)
	END IF
	IF (operative(3).EQ..TRUE.) THEN
		CALL LevenMarqB(XLM, XFB, IPARAM)
	END IF
END IF

!iter = iter + 1

END DO
END DO
END DO
END DO
END DO
END DO
END DO
END DO
END DO
END DO
END DO
END DO

END SUBROUTINE BruteForce
! ============================================================