! ============================================================
SUBROUTINE Execute(filename, good, v, bndsrcL, bndsrcU, dXc, operative)
!DEC$ ATTRIBUTES DLLEXPORT :: Execute

USE Globals_class, ONLY : dimXc, dimX, erase, AssignX, AssignB, A, omega, phi, dl0, l0, dth0, th0, dps0, ps0, fb1, fb2, fb3,&
						  active, brute, tunnel, XLB, XUB
USE ReadFiles_class
USE LeastSquares_class
USE Verbatim_class, ONLY : Verba

! Subroutine che gestisce il flusso dell'elaborazione
!
! PARAMETRI DI INPUT
!
! PARAMETRI DI OUTPUT:

IMPLICIT NONE

! Variables
CHARACTER(LEN=*), INTENT(IN) :: filename
INTEGER, INTENT(IN) :: dXc
REAL(8), INTENT(IN) :: v(dXc), bndsrcL(dXc), bndsrcU(dXc)
LOGICAL, INTENT(IN) :: operative(3), good(dXc)
INTEGER, PARAMETER :: m = 100
REAL(8), PARAMETER :: TOLLs = 1.d-6, TOLL = 1.d-2
INTEGER :: p, IPARAM(7) !, iter
!CHARACTER(LEN=10) :: it
REAL(8), ALLOCATABLE :: X(:), XF(:), XFB(:), XLM(:), F(:)

! Inizio procedimento
dimXc = dXc
brute = .FALSE.

IF (ALLOCATED(active)) DEALLOCATE(active)
ALLOCATE(active(dimXc))
active = good

erase = 0.d0
DO p = 1, dimXc
	IF (active(p).EQ..FALSE.) erase = erase+1
END DO
dimX = dimXc-erase

OPEN(UNIT=6, FILE='lsnl.wri', STATUS='REPLACE', ACTION='WRITE')
OPEN(UNIT=7, FILE='modres.dat', STATUS='REPLACE', ACTION='WRITE')
OPEN(UNIT=8, FILE='output.wri', STATUS='REPLACE', ACTION='WRITE')

!iter = 1

A = v(1)
omega = v(2)
phi = v(3)
dl0 = v(4)
l0 = v(5)
dth0 = v(6)
th0 = v(7)
dps0 = v(8)
ps0 = v(9)
fb1 = v(10)
fb2 = v(11)
fb3 = v(12)

!fb3=SQRT(1.1d0**2.d0-fb2**2.d0)

!WRITE (it, FMT='(I10)') iter
WRITE(8,*) 'A     : ', A
WRITE(8,*) 'omega : ', omega
WRITE(8,*) 'phi   : ', phi
WRITE(8,*) 'dl_0  : ', dl0
WRITE(8,*) 'l_0   : ', l0
WRITE(8,*) 'dt_0  : ', dth0
WRITE(8,*) 't_0   : ', th0
WRITE(8,*) 'dps_0 : ', dps0
WRITE(8,*) 'ps_0  : ', ps0
WRITE(8,*) 'f_b_1 : ', fb1
WRITE(8,*) 'f_b_2 : ', fb2
WRITE(8,*) 'f_b_3 : ', fb3

IF (ALLOCATED(X)) DEALLOCATE(X)
IF (ALLOCATED(XLB)) DEALLOCATE(XLB)
IF (ALLOCATED(XUB)) DEALLOCATE(XUB)
ALLOCATE(X(dimX))
ALLOCATE(XLB(dimX))
ALLOCATE(XUB(dimX))
CALL AssignX(X)
CALL AssignB(bndsrcL, bndsrcU, XLB, XUB)

IF ((operative(2).EQ..TRUE.).OR.(operative(3).EQ..TRUE.)) THEN
	IF (ALLOCATED(XLM)) DEALLOCATE(XLM)
	ALLOCATE(XLM(dimX))
	XLM = X
END IF

IF (operative(2).EQ..TRUE.) THEN
	IF (ALLOCATED(XF)) DEALLOCATE(XF)
	ALLOCATE(XF(dimX))
END IF

IF (operative(3).EQ..TRUE.) THEN
	IF (ALLOCATED(XFB)) DEALLOCATE(XFB)
	ALLOCATE(XFB(dimX))
END IF

CALL ReadFile(filename)

tunnel = .FALSE.

IF ((operative(1).EQ..FALSE.).AND.(operative(2).EQ..FALSE.).AND.(operative(3).EQ..FALSE.)) THEN
	CALL Tunneling(X, 100, 100, X)
	tunnel = .FALSE.
	IF (ALLOCATED(F)) DEALLOCATE(F)
	ALLOCATE(F(dimRed))
	CALL R(dimRed, dimX, X, F)
ELSE
	IF (operative(1).EQ..TRUE.) THEN
		CALL LeastSquares(X, TOLLs, TOLL, m)
	END IF
	IF (operative(2).EQ..TRUE.) THEN
		CALL LevenMarq(XLM, XF, IPARAM)
	END IF
	IF (operative(3).EQ..TRUE.) THEN
		CALL LevenMarqB(XLM, XFB, IPARAM)
	END IF
END IF

!iter = iter + 1

tunnel = .TRUE.

IF (operative(1).EQ..TRUE.) THEN
	WRITE(8, *)
	WRITE(8, *) 'Non linear Least Square:'
	WRITE(8, FMT='(F15.10)') X
END IF
IF (operative(2).EQ..TRUE.) THEN
	CALL Verba(XF, IPARAM(1:6))
	WRITE(8, *)
	WRITE(8, *) 'Levenberg-Marquardt Least Square:'
	WRITE(8, FMT='(F15.10)') XF
END IF
IF (operative(3).EQ..TRUE.) THEN
	CALL Verba(XFB, IPARAM(1:6))
	WRITE(8, *)
	WRITE(8, *) 'Bounded Least Square:'
	WRITE(8, FMT='(F15.10)') XFB
END IF

END SUBROUTINE Execute
! ============================================================