MODULE LeastSquares_class

USE Numerical_libraries
USE Globals_class, ONLY : dimX, dimRed, rms, AssignP
USE Vectors_class
USE AsceDecl_class
USE Param_class
USE Derivates_class

! Modulo per l'applicazione del medodo dei Minimi Quadrati

IMPLICIT NONE

CONTAINS

! ============================================================
SUBROUTINE LeaSquaLin(X, TOLL, m)

! realizzazione del metodo dei Minimi Quadrati tramite SVD

! Variables
INTEGER, INTENT(IN) :: m
REAL(8), INTENT(IN) :: TOLL
REAL(8), INTENT(INOUT) :: X(dimX)
INTEGER :: p, q, i, j, JRr, Nr
REAL(8) :: V(dimRed), Var, N(dimX,dimX), InvN(dimX,dimX), CovX(dimX,dimX), devSt(dimX), rho(dimX,dimX)
REAL(8) :: Rx(dimRed), JRx(dimRed,dimX), InvJRx(dimX,dimRed)
COMPLEX(8) :: EVAL(dimX-erase)

! Inizio procedimento
DO p = 1, m
	WRITE(6,*) 'p : ', p
	CALL AssignP(X)
	CALL R(dimRed, dimX, X, Rx)
	CALL JR(dimRed, dimX, X, JRx, dimRed)

	CALL DLSGRR(dimRed, dimX, JRx, dimRed, 1.d-20, JRr, InvJRx, dimX)

	CALL DEVLRG(dimX, InvJRx, dimX, EVAL)
	CALL DWRCRN('EVAL', dimX, 1, EVAL, dimX, 0)

	X = MATMUL(InvJRx, Rx)
	
	! Scarti:
	V = MATMUL(JRx, X)-Rx

	! Varianza
	Var = DOT_PRODUCT(V, V)/(dimRed-dimX)

	N = MATMUL(TRANSPOSE(JRx),JRx)

	CALL DLSGRR(dimX, dimX, N, dimX, 1.d-20, Nr, InvN, dimX)
!	CALL DLINRG(dimX, N, dimX, InvN, dimX)

	CovX = Var*InvN

!	CovV = Var*(identity_matrix(dimRed)-MATMUL(MATMUL(JR, InvN), TRANSPOSE(JR))

	DO q = 1, dimX
		devSt(q) = SQRT(CovX(q,q))
	END DO

	DO i = 1, dimX
		DO j = 1, dimX
			rho(i,j) = CovX(i,j)/(devSt(i)*devSt(j))
		END DO
	END DO
	
	CALL DWRRRN ('Covariance', dimX, dimX, CovX, dimX, 0)
	CALL DWRRRN ('Dev Stand', dimX, 1, DevSt, dimX, 0)
	WRITE(6,*)
	WRITE(6,*) 'Var : ', Var
	WRITE(6,*)
	CALL DWRRRN ('X', dimX, 1, X, dimX, 0)
	CALL DWRRRN ('Indici correlaz', dimX, dimX, rho, dimX, 0)

	IF (Var<TOLL) EXIT

END DO

END SUBROUTINE LeaSquaLin
! ============================================================

END MODULE LeastSquares_class