MODULE Verbatim_class

USE Numerical_libraries
USE Globals_class, ONLY : brute, tunnel, dimX, dimRed, AssignP
USE Param_class, ONLY : R

! Modulo che contiene 
!
! PUBLIC FUNCTIONS:

IMPLICIT NONE

CONTAINS

! ============================================================
SUBROUTINE Verba(XF, IPARAM)

! 

IMPLICIT NONE

! Variabili
INTEGER, INTENT(IN) :: IPARAM(6)
REAL(8), INTENT(IN) :: XF(dimX)
REAL(8) :: Rx(dimRed), SR, RMS, Sig0

! Inizio procedimento
CALL R(dimRed, dimX, XF, Rx)
SR = 0.5d0*DOT_PRODUCT(Rx,Rx)
RMS = SQRT(DOT_PRODUCT(Rx, Rx)/(dimRed-dimX))
! Varianza unitaria
Sig0 = DOT_PRODUCT(Rx, Rx)/(dimRed-dimX)

tunnel = .TRUE.

IF (brute.EQ..FALSE.) THEN
	!'The solution is'
	WRITE(6, *)
	WRITE(6, *) 'Soluzione: ', XF
	WRITE(6, *)
	WRITE(6, *) 'The number of iterations is: ', IPARAM(3)
	WRITE(6, *)
	WRITE(6, *) 'The number of function evaluations is: ', IPARAM(4)
	WRITE(6, *)
	WRITE(6, *) 'The number of Jacobian evaluations is: ', IPARAM(5)
	WRITE(6, *)
	WRITE(6, *) 'RMS : ', RMS
	WRITE(6, *)
	WRITE(6, *) 'Var0 : ', Sig0
	WRITE(6, *)
	WRITE(6, *) 'SR : ', SR
	WRITE(6, *)
ELSE
	WRITE(6,100) XF, XF, RMS, Sig0, SR, IPARAM(3), IPARAM(4), IPARAM(5)
	100 FORMAT(8F10.5, 10F45.40, 2X, F45.40, 2X, 3I5)
END IF

END SUBROUTINE Verba
! ============================================================

END MODULE Verbatim_class